%global perl_version 5.36.0
%global perl_version_short 5.36 
%global perl_compat perl(:MODULE_COMPAT_%{perl_version})

%global __provides_exclude perl\\((DB\\)$)|^perl\\((charnames|DynaLoader|Tie::Hash|ExtUtils::MakeMaker::_version)\\)$|^perl\\(CPAN::Meta::Requirements\\)
%global __requires_exclude perl\\((VMS|Mac::)

%global privlib     %{_prefix}/share/perl5
%global archlib     %{_libdir}/perl5
%global perl_vendorlib  %{privlib}/vendor_perl
%global perl_vendorarch %{archlib}/vendor_perl

%global new_perl LD_PRELOAD="%{buildroot}%{archlib}/CORE/libperl.so" \\\
    LD_LIBRARY_PATH="%{buildroot}%{archlib}/CORE" \\\
    PERL5LIB="%{buildroot}%{archlib}:%{buildroot}%{privlib}" \\\
    %{buildroot}%{_bindir}/perl

%undefine _package_note_file

Summary:        Practical Extraction and Report Language
Name:           perl
Version:        %{perl_version}
Release:        8%{?dist}
License:        GPL+ or Artistic
URL:            https://www.perl.org/
Source0:		https://www.cpan.org/src/5.0/%{name}-%{perl_version}.tar.xz
Source1:        macros.perl
Source2:        perl.stp
Source3:        perl-example.stp
Source4:        Pod-Html-license-clarification
Source5:        gendep.macros
Source6:		bootstrap-packages
Source7:		remove-unpackaged-files
%if 0%{?perl_bootstrap}
%include %{SOURCE5}
%endif

Patch0001:      0001-perl-5.36.0-Change-verify_SSL-default-to-1-add-ENV-v.patch
Patch0002:      0001-perl-5.36.0-Add-verify_SSL-1-to-HTTP-Tiny-in-CPAN-HT.patch
Patch0003:      0001-perl-5.36.0-Fix-read-write-past-buffer-end-perl-secu.patch
Patch3000:		perl-5.8.0-libdir64.patch
Patch3001:		perl-USE_MM_LD_RUN_PATH.patch
Patch3002:		perl-5.22.1-Provide-ExtUtils-MM-methods-as-standalone-ExtUtils-M.patch
Patch3003:      perl-5.22.1-Replace-EU-MM-dependnecy-with-EU-MM-Utils-in-IPC-Cmd.patch
Patch3004:      perl-5.16.3-create_libperl_soname.patch
Patch3005:      perl-5.22.0-Install-libperl.so-to-shrpdir-on-Linux.patch
Patch3006:      perl-5.34.0-Destroy-GDBM-NDBM-ODBM-SDBM-_File-objects-only-from-.patch
Patch3007:      perl-5.16.3-Link-XS-modules-to-libperl.so-with-EU-CBuilder-on-Li.patch
Patch3008:      perl-5.16.3-Link-XS-modules-to-libperl.so-with-EU-MM-on-Linux.patch

BuildRequires:  bash coreutils findutils gcc make sed tar gcc-c++ procps
BuildRequires:  bzip2-devel gdbm-devel glibc-common groff-base
BuildRequires:  libdb-devel systemtap-sdt-devel zlib-devel
%if ! 0%{?perl_bootstrap}
BuildRequires:  perl-interpreter perl-generators
%endif
Requires:       %perl_compat
Requires:       perl-interpreter = %{perl_version}-%{release}
Requires:       perl-libs = %{perl_version}-%{release}
Requires:       perl-devel = %{perl_version}-%{release}
Requires:       perl-macros perl-utils perl-Archive-Tar perl-Attribute-Handlers perl-Carp
Requires:		perl-autodie perl-AutoLoader perl-AutoSplit perl-autouse perl-B perl-base
Requires:       perl-Benchmark perl-bignum perl-blib perl-CPAN perl-Class-Struct perl-mro
Requires:       perl-Compress-Raw-Bzip2 perl-Compress-Raw-Zlib perl-constant perl-doc
Requires:       perl-Config-Extensions perl-Config-Perl-V perl-CPAN-Meta-Requirements
Requires:       perl-CPAN-Meta perl-CPAN-Meta-YAML perl-Data-Dumper perl-DBM_Filter
Requires:       perl-deprecate perl-DirHandle perl-Dumpvalue perl-DynaLoader perl-debugger
Requires:       perl-Devel-Peek perl-Devel-PPPort perl-Devel-SelfStubber perl-DB_File
Requires:       perl-diagnostics perl-Digest perl-Digest-MD5 perl-Digest-SHA perl-ph
Requires:       perl-Encode perl-Encode-devel perl-encoding perl-English perl-MIME-Base64
Requires:       perl-encoding-warnings perl-ExtUtils-Command perl-FindBin perl-Storable
Requires:       perl-Env perl-Errno perl-experimental perl-Exporter perl-Fcntl perl-subs
Requires:       perl-ExtUtils-CBuilder perl-ExtUtils-Constant perl-ExtUtils-Embed
Requires:       perl-ExtUtils-MakeMaker perl-ExtUtils-Manifest perl-ExtUtils-Install
Requires:       perl-ExtUtils-Miniperl perl-ExtUtils-MM-Utils perl-ExtUtils-ParseXS
Requires:       perl-File-Basename perl-File-Compare perl-File-Copy perl-fields perl-lib
Requires:       perl-File-DosGlob perl-File-Fetch perl-FileCache perl-FileHandle perl-if
Requires:       perl-File-Find perl-File-Path perl-File-stat perl-File-Temp perl-filetest
Requires:       perl-Filter perl-Filter-Simple perl-less perl-JSON-PP perl-HTTP-Tiny
Requires:       perl-GDBM_File perl-NDBM_File perl-ODBM_File perl-libnet perl-libnetcfg
Requires:       perl-Getopt-Long perl-Getopt-Std perl-Hash-Util perl-Hash-Util-FieldHash
Requires:       perl-IO perl-IO-Compress perl-IO-Socket-IP perl-IO-Zlib perl-IPC-Cmd
Requires:       perl-IPC-Open3 perl-IPC-SysV perl-I18N-Collate perl-I18N-Langinfo
Requires:       perl-I18N-LangTags perl-meta-notation perl-Net perl-Net-Ping perl-NEXT
Requires:       perl-locale perl-Locale-Maketext perl-Locale-Maketext-Simple perl-Memoize
Requires:       perl-Math-BigInt perl-Math-BigInt-FastCalc perl-Math-BigRat perl-Math-Complex
Requires:       perl-Module-CoreList perl-Module-CoreList-tools perl-Module-Load-Conditional
Requires:       perl-Module-Loaded perl-Module-Metadata perl-Module-Load perl-Opcode
Requires:       perl-open perl-overload perl-overloading perl-parent perl-PathTools
Requires:       perl-Params-Check perl-perlfaq perl-PerlIO-via-QuotedPrint perl-Perl-OSType
Requires:       perl-Pod-Checker perl-Pod-Escapes perl-Pod-Functions perl-Pod-Perldoc
Requires:       perl-Pod-Simple perl-Pod-Usage perl-podlators perl-POSIX perl-Pod-Html
Requires:       perl-Safe perl-Scalar-List-Utils perl-Search-Dict perl-SelectSaver
Requires:       perl-SelfLoader perl-sigtrap perl-Socket perl-sort perl-Sys-Hostname
Requires:       perl-Symbol perl-Sys-Syslog perl-Term-ANSIColor perl-Term-Cap
Requires:       perl-Term-ReadLine perl-Term-Complete perl-Text-Tabs+Wrap perl-vmsish
Requires:       perl-Text-Abbrev perl-Text-Balanced perl-Text-ParseWords perl-version
Requires:       perl-Thread perl-Thread-Queue perl-Thread-Semaphore perl-User-pwent
Requires:       perl-threads perl-threads-shared perl-vars perl-Tie perl-Tie-File
Requires:       perl-Tie-Memoize perl-Tie-RefHash perl-Unicode-Normalize perl-Unicode-UCD
Requires:       perl-Unicode-Collate perl-Time perl-Time-HiRes perl-Time-Local perl-Time-Piece
Requires:       perl-Test perl-Test-Harness perl-Test-Simple 
Provides:       perl-core = %{perl_version}-%{release}

%description
Perl is a general-purpose programming language originally developed for 
text manipulation and now used for a wide range of tasks including system 
administration, web development, network programming, GUI development, and 
more.

The language is intended to be practical (easy to use, efficient, complete) 
rather than beautiful (tiny, elegant, minimal). Its major features are that 
it's easy to use, supports both procedural and object-oriented (OO) programming,
has powerful built-in support for text processing, and has one of the world's 
most impressive collections of third-party modules.

%package interpreter
Summary:        The Perl 5 language interpreter
License:        GPL+ or Artistic
Requires:       perl-libs = %{perl_version}-%{release}
Requires:       %perl_compat
Suggests:       perl-doc = %{perl_version}-%{release}
Requires(post): perl-libs

%description interpreter
This package provides the perl 5 language interpreter. Perl officially stands 
for Practical Extraction and Report Language, except when it doesn't.

Perl was originally a language optimized for scanning arbitrary text files, 
extracting information from those text files, and printing reports based on 
that information. It quickly became a good language for many system management 
tasks. Over the years, Perl has grown into a general-purpose programming 
language. It's widely used for everything from quick "one-liners" to 
full-scale application development.

%package libs
Summary:        Libraries and perl modules for the perl run-time
License:        (GPL+ or Artistic) and BSD and HSRL and MIT and UCD and Public domain
Requires:       perl(DynaLoader) perl(Encode) perl(File::Spec)
Provides:       %perl_compat
Provides:       perl(:VERSION) = %{perl_version}
Provides:       perl(:WITH_64BIT) perl(:WITH_ITHREADS) 
Provides:		perl(:WITH_THREADS) perl(:WITH_PERLIO)
Provides:       perl(:WITH_LARGEFILES) perl(unicore::Name) 
Provides:       perl(bytes_heavy.pl) perl(utf8_heavy.pl)
Suggests:       perl(DB_File) perl(GDBM_File) perl(ODBM_File)
Recommends:     perl(NDBM_File)
%if 0%{?perl_bootstrap}
%gendep_perl_libs
%endif

%description libs
This package provides libraries and perl modules for the perl run-time.

%package devel
Summary:        Header files and libraries for perl development
License:        (GPL+ or Artistic) and UCD
Requires:       %perl_compat
Requires:       systemtap-sdt-devel libxcrypt-devel
Requires:       perl(ExtUtils::ParseXS) perl(Devel::PPPort)
Requires:       perl-libs = %{perl_version}-%{release}
Recommends:     perl-doc = %{perl_version}-%{release}
%if 0%{?perl_bootstrap}
%gendep_perl_devel
%endif

%description devel
This package provides header files and libraries for perl development.

%package debugger
Summary:        Perl debugging
Version:        1.60
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Cwd) perl(feature) perl(IO::Socket) perl(mro) perl(Term::ReadLine)
Requires:       perl(threads) perl(threads::shared) perl(vars) perl(warnings)
Requires:       perl(meta_notation) = %{perl_version}
Recommends:     perl(Carp) perl(Config) perl(Devel::Peek) perl(IO::Handle)
Recommends:     perl(File::Basename) perl(File::Path) perl(POSIX)
%if ! 0%{?perl_bootstrap}
Suggests:       perl(PadWalker) >= 0.08
%endif
%if 0%{?perl_bootstrap}
%gendep_perl_debugger
%endif
Provides:       perl(dumpvar.pl) = %{perl_version}
Provides:       perl(perl5db.pl) = %{version}
BuildArch:      noarch

%description debugger
This is the perl debugging. If you invoke Perl with the -d switch, your script runs 
under the Perl source debugger. This works like an interactive Perl environment, 
prompting for debugger commands that let you examine source code, set breakpoints, 
get stack backtraces, change the values of variables, etc. This is so convenient 
that you often fire up the debugger all by itself just to test out Perl constructs
interactively to see what they do.

%package doc
Summary:        Perl language documentation
Version:        %{perl_version}
License:        (GPL+ or Artistic) and UCD and Public Domain
Requires:       %perl_compat
Recommends:     perl-Pod-Perldoc
BuildArch:      noarch

%description doc
This is a documentation for Perl language. It's provided in POD and manual
page format.

%package macros
Summary:        Macros for rpmbuild
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl-interpreter
BuildArch:      noarch

%description macros
This package provides RPM macros for rpmbuild.

%package utils
Summary:        Utilities packaged with the Perl distribution
Version:        %{perl_version}
License:        GPL+ or Artistic
Requires:       perl-libs = %{perl_version}-%{release}
%if 0%{?perl_bootstrap}
%gendep_perl_utils
%endif
BuildArch:      noarch

%description utils
Along with the Perl interpreter itself, the Perl distribution installs a 
range of utilities on your system. There are also several utilities which
are used by the Perl distribution itself as part of the install process. 

%package Attribute-Handlers
Summary:        Simpler definition of attribute handlers
Version:        1.02
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Attribute_Handlers
%endif
BuildArch:      noarch

%description Attribute-Handlers
This Perl module, when inherited by a package, allows that package's class 
to define attribute handler subroutines for specific attributes. Variables 
and subroutines subsequently defined in that package, or in packages derived 
from that package may be given attributes with the same names as the attribute
handler subroutines, which will then be called in one of the compilation
phases (i.e. in a "BEGIN", "CHECK", "INIT", or "END" block).

%package AutoLoader
Summary:        Load subroutines only on demand
Version:        5.74
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_AutoLoader
%endif
BuildArch:      noarch

%description AutoLoader
The AutoLoader module works with the AutoSplit module and the __END__ token
to defer the loading of some subroutines until they are used rather than
loading them all at once.

%package AutoSplit
Summary:        Split a package for autoloading
Version:        5.74
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_AutoSplit
%endif
BuildArch:      noarch

%description AutoSplit
This function will split up your program into files that the AutoLoader module 
can handle. It is used by both the standard perl libraries and by the MakeMaker 
utility, to automatically configure libraries for autoloading.

The autosplit interface splits the specified file into a hierarchy rooted at the
directory $dir. It creates directories as needed to reflect class hierarchy, and 
creates the file autosplit.ix. This file acts as both forward declaration of all 
package routines, and as timestamp for the last update of the hierarchy.

%package autouse
Summary:        Postpone load of modules until a function is used
Version:        1.11
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(warnings)
%if 0%{?perl_bootstrap}
%gendep_perl_autouse
%endif
BuildArch:      noarch

%description autouse
If the module Module is already loaded, then the declaration

	use autouse 'Module' => qw(func1 func2($;$));

is equivalent to

	use Module qw(func1 func2);

if Module defines func2() with prototype ($;$), and func1() has no prototypes. 
(At least if Module uses Exporter's import, otherwise it is a fatal error.)

If the module Module is not loaded yet, then the above declaration declares 
functions func1() and func2() in the current package. When these functions are 
called, they load the package Module if needed, and substitute themselves with 
the correct definitions.

%package B
Summary:        The Perl Compiler Backend
Version:        1.83
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Data::Dumper) perl(overloading) perl(XSLoader)
%if 0%{?perl_bootstrap}
%gendep_perl_B
%endif

%description B
The B module supplies classes which allow a Perl program to delve into its own 
innards. It is the module used to implement the "backends" of the Perl compiler. 
Usage of the compiler does not require knowledge of this module: see the O module 
for the user-visible part. The B module is of use to those who want to write new 
compiler backends. 

%package base
Summary:        Establish an ISA relationship with base classes at compile time
Version:        2.27
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_base
%endif
BuildArch:      noarch

%description base
base module allows you to both load one or more modules, while setting up inheritance from 
those modules at the same time.

When base tries to require a module, it will not die if it cannot find the module's file, 
but will die on any other error. After all this, should your base class be empty, containing 
no symbols, base will die. This is useful for inheriting from classes in the same file as 
yourself but where the filename does not match the base module name.

base will also initialize the fields if one of the base classes has it. Multiple inheritance 
of fields is NOT supported, if two or more base classes each have inheritable fields the 'base'
pragma will croak. See fields for a description of this feature.

%package Benchmark
Summary:        Benchmark running times of Perl code
Version:        1.23
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Benchmark
%endif
BuildArch:      noarch

%description Benchmark
The Benchmark module encapsulates a number of routines to help you figure out how long it 
takes to execute some code.
timethis - run a chunk of code several times
timethese - run several chunks of code several times
cmpthese - print results of timethese as a comparison chart
timeit - run a chunk of code and see how long it goes
countit - see how many times a chunk of code runs in a given time

%package blib
Summary:        Use MakeMaker's uninstalled version of a package
Version:        1.07
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_blib
%endif
BuildArch:      noarch

%description blib
Looks for MakeMaker-like 'blib' directory structure starting in dir (or 
current directory) and working back up to five levels of '..'. Intended 
for use on command line with -M option as a way of testing arbitrary 
scripts against an uninstalled version of a package.

%package Class-Struct
Summary:        Declare struct-like datatypes as Perl classes
Version:        0.66
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Class_Struct
%endif
BuildArch:      noarch

%description Class-Struct
Class::Struct exports a single function, struct. Given a list of element names 
and types, and optionally a class name, struct creates a Perl 5 class that 
implements a "struct-like" data structure.

%package Config-Extensions
Summary:        Hash lookup of which Perl core extensions were built
Version:        0.03
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Config_Extensions
%endif
BuildArch:      noarch

%description Config-Extensions
The Config::Extensions module provides a hash %%Extensions containing all the
core extensions that were enabled for this perl.

%package DBM_Filter
Summary:        Filter DBM keys and values
Version:        0.06
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Compress::Zlib) perl(Encode)
%if 0%{?perl_bootstrap}
%gendep_perl_DBM_Filter
%endif
BuildArch:      noarch

%description DBM_Filter
This module provides an interface that allows filters to be applied to tied
hashes associated with DBM files.

%package deprecate
Summary:        Perl pragma for deprecating the inclusion of a module in core
Version:        0.04
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(Config)
%if 0%{?perl_bootstrap}
%gendep_perl_deprecate
%endif
BuildArch:      noarch

%description deprecate
This pragma simplifies the maintenance of dual-life modules that will no longer 
be included in the Perl core in a future Perl release, but are still included 
currently.

The purpose of the pragma is to alert users to the status of such a module by 
issuing a warning that encourages them to install the module from CPAN, so that 
a future upgrade to a perl which omits the module will not break their code.

%package Devel-Peek
Summary:        A data debugging tool for the XS programmer
Version:        1.32
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Devel_Peek
%endif

%description Devel-Peek
Devel::Peek contains functions which allows raw Perl datatypes to be manipulated 
from a Perl script. This is used by those who do XS programming to check that the 
data they are sending from C to Perl looks as they think it should look. The trick, 
then, is to know what the raw datatype is supposed to look like when it gets to Perl.

%package Devel-SelfStubber
Summary:        Generate stubs for a SelfLoading module
Version:        1.06
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Devel_SelfStubber
%endif
BuildArch:      noarch

%description Devel-SelfStubber
Devel::SelfStubber prints the stubs you need to put in the module before the
__DATA__ token (or you can get it to print the entire module with stubs
correctly placed). The stubs ensure that if a method is called, it will get
loaded. They are needed specifically for inherited autoloaded methods.

%package diagnostics
Summary:        Produce verbose warning diagnostics
Version:        1.39
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl-libs = %{perl_version}-%{release}
Requires:       perl(Getopt::Std)
%if 0%{?perl_bootstrap}
%gendep_perl_diagnostics
%endif
BuildArch:      noarch

%description diagnostics
This module extends the terse diagnostics normally emitted by both the perl 
compiler and the perl interpreter (from running perl with a -w switch or use 
warnings), augmenting them with the more explicative and endearing descriptions 
found in perldiag. Like the other pragmata, it affects the compilation phase 
of your program rather than merely the execution phase.

%package DirHandle
Summary:        Supply object methods for directory handles
Version:        1.05
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(warnings)
%if 0%{?perl_bootstrap}
%gendep_perl_DirHandle
%endif
BuildArch:      noarch

%description DirHandle
There is no reason to use this module nowadays. The DirHandle module provides an 
alternative interface to the opendir(), closedir(), readdir(), and rewinddir() 
functions. 

Up to Perl 5.5, opendir() could not autovivify a directory handle from undef, so 
using a lexical handle required using a function from Symbol to create an anonymous 
glob, which took a separate step. DirHandle encapsulates this, which allowed cleaner 
code than opendir(). Since Perl 5.6, opendir() alone has been all you need for 
lexical handles.

%package Dumpvalue
Summary:        Provides screen dump of Perl data
Version:        2.27
License:        GPL+ or Artistic
Requires:       %perl_compat
Recommends:     perl(Devel::Peek)
%if 0%{?perl_bootstrap}
%gendep_perl_Dumpvalue
%endif
BuildArch:      noarch

%description Dumpvalue
This package provides screen dump of Perl data.

%package DynaLoader
Summary:        Dynamically load C libraries into Perl code
Version:        1.52
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_DynaLoader
%endif

%description DynaLoader
The DynaLoader module defines a standard generic interface to the dynamic linking 
mechanisms available on many platforms. Its primary purpose is to implement automatic 
dynamic loading of Perl modules. 

%package encoding-warnings
Summary:        Warn on implicit encoding conversions
Version:        0.13
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_encoding_warnings
%endif
BuildArch:      noarch

%description encoding-warnings
As of Perl 5.26.0, this module has no effect. The internal Perl feature that was 
used to implement this module has been removed.  Hence, if you load this module 
on Perl 5.26.0, you will get one warning that the module is no longer supported;
and the module will do nothing thereafter.

%package English
Summary:        Use nice English (or awk) names for ugly punctuation variables
Version:        1.11
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(warnings)
%if 0%{?perl_bootstrap}
%gendep_perl_English
%endif
BuildArch:      noarch

%description English
This module provides aliases for the built-in variables whose names no one seems 
to like to read. Variables with side-effects which get triggered just by accessing 
them (like $0) will still be affected.

%package Errno
Summary:        System errno constants
Version:        1.36
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl-libs = %{perl_version}-%{release}
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_Errno
%endif

%description Errno
"Errno" defines and conditionally exports all the error constants defined in your 
system "errno.h" include file. It has a single export tag, ":POSIX", which will 
export all POSIX defined error numbers.

%package ExtUtils-Constant
Summary:        Generate XS code to import C header constants
Version:        0.25
License:        GPL+ or Artistic
BuildArch:      noarch
Requires:       %perl_compat
Requires:       perl(Data::Dumper)
%if 0%{?perl_bootstrap}
%gendep_perl_ExtUtils_Constant
%endif

%description ExtUtils-Constant
ExtUtils::Constant facilitates generating C and XS wrapper code to allow Perl 
modules to AUTOLOAD constants defined in C library header files. It is principally 
used by the h2xs utility, on which this code is based. It doesn't contain the
routines to scan header files to extract these constants.

%package ExtUtils-Embed
Summary:        Utilities for embedding Perl in C/C++ applications
Version:        1.35
License:        GPL+ or Artistic
Requires:       perl-devel
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_ExtUtils_Embed
%endif
BuildArch:      noarch

%description ExtUtils-Embed
ExtUtils::Embed provides utility functions for embedding a Perl interpreter 
and extensions in your C/C++ applications. Typically, an application Makefile 
will invoke ExtUtils::Embed functions while building your application.

%package ExtUtils-Miniperl
Summary:        Write the C code for miniperlmain.c and perlmain.c
Version:        1.11
License:        GPL+ or Artistic
Requires:       perl-devel
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_ExtUtils_Miniperl
%endif
BuildArch:      noarch

%description ExtUtils-Miniperl
writemain() takes an argument list of directories containing archive libraries
that relate to perl modules and should be linked into a new perl binary. It
writes a corresponding perlmain.c file that is a plain C file containing all
the bootstrap code to make the If the first argument to writemain() is a
reference to a scalar it is used as the file name to open for output. Any other
reference is used as the file handle to write to. Otherwise output defaults to
STDOUT.

%package Fcntl
Summary:        Load the C Fcntl.h defines
Version:        1.15
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Fcntl
%endif

%description Fcntl
This module is just a translation of the C fcntl.h file. Unlike the old 
mechanism of requiring a translated fcntl.ph file, this uses the h2xs 
program (see the Perl source distribution) and your native C compiler. 
This means that it has a far more likely chance of getting the numbers right.

%package fields
Summary:        Compile-time class fields
Version:        2.27
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(base)
Requires:       perl(Carp)
Requires:       perl(Hash::Util)
%if 0%{?perl_bootstrap}
%gendep_perl_fields
%endif
BuildArch:      noarch

%description fields
The "fields" pragma enables compile-time and run-time verified class fields.

%package File-Basename
Summary:        Parse file paths into directory, file name, and suffix
Version:        2.85
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(re)
%if 0%{?perl_bootstrap}
%gendep_perl_File_Basename
%endif
BuildArch:      noarch

%description File-Basename
These routines allow you to parse file paths into their directory, file name,
and suffix.

%package File-Compare
Summary:        Compare files or file handles
Version:        1.100.700
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_File_Compare
%endif
BuildArch:      noarch

%description File-Compare
A File::Compare Perl module provides functions for comparing a content of two
files specified by a file name or a file handle.

%package File-Copy
Summary:        Copy files or file handles
Version:        2.39
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(File::Basename)
%if 0%{?perl_bootstrap}
%gendep_perl_File_Copy
%endif
BuildArch:      noarch

%description File-Copy
A File::Copy module provides two basic functions, copy and move, which are
useful for getting the contents of a file from one place to another.

%package File-DosGlob
Summary:        DOS-like globbing
Version:        1.12
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Text::ParseWords)
%if 0%{?perl_bootstrap}
%gendep_perl_File_DosGlob
%endif

%description File-DosGlob
This Perl module implements DOS-like globbing with a few enhancements. It
is largely compatible with perlglob.exe in all but one respect--it understands
wild cards in directory components.

%package File-Find
Summary:        Traverse a directory tree
Version:        1.40
License:        GPL+ or Artistic
Requires:       %perl_compat
Recommends:     perl(Scalar::Util)
%if 0%{?perl_bootstrap}
%gendep_perl_File_Find
%endif
BuildArch:      noarch

%description File-Find
These are functions for searching through directory trees doing work on each
file found similar to the Unix find command.

%package File-stat
Summary:        By-name interface to Perl built-in stat functions
Version:        1.12
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Symbol)
%if 0%{?perl_bootstrap}
%gendep_perl_File_stat
%endif
BuildArch:      noarch

%description File-stat
This module overrides the core stat() and lstat() functions, replacing them
with versions that return File::stat objects. This object has methods that
return the similarly named structure field name from the stat(2) function.

%package FileCache
Summary:        Keep more files open than the system permits
Version:        1.10
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_FileCache
%endif
BuildArch:      noarch

%description FileCache
The "cacheout" function will make sure that there's a file handle open
for reading or writing available as the path name you give it. It
automatically closes and re-opens files if you exceed your system
maximum number of file descriptors, or the suggested maximum.

%package FileHandle
Summary:        Object methods for file handles
Version:        2.03
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Exporter)
Recommends:     perl(Fcntl)
%if 0%{?perl_bootstrap}
%gendep_perl_FileHandle
%endif
BuildArch:      noarch

%description FileHandle
This is an object-oriented interface for opening files and performing
input/output operations on them.

%package filetest
Summary:        Perl pragma to control the filetest permission operators
Version:        1.03
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_filetest
%endif
BuildArch:      noarch

%description filetest
The default behavior of file test operators (e.g. "-r") is to use the simple
mode bits as returned by the stat() family of system calls. However, many
operating systems have additional features to define more complex access
rights, for example ACLs (Access Control Lists). For such environments, "use
filetest" may help the permission operators to return results more consistent
with other tools.

%package FindBin
Summary:        Locate a directory of an original Perl script
Version:        1.53
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_FindBin
%endif
BuildArch:      noarch

%description FindBin
Locates the full path to the script bin directory to allow the use of paths
relative to the bin directory.

%package GDBM_File
Summary:        Perl5 access to the gdbm library
Version:        1.23
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_GDBM_File
%endif

%description GDBM_File
GDBM_File is a module which allows Perl programs to make use of the facilities
provided by the GNU gdbm library.

%package Getopt-Std
Summary:        Process single-character switches with switch clustering
Version:        1.13
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Getopt_Std
%endif
BuildArch:      noarch

%description Getopt-Std
The Getopt::Std module provides functions for processing single-character
switches with switch clustering. Pass one argument which is a string
containing all switches to be recognized.

%package Hash-Util
Summary:        General-utility hash subroutines
Version:        0.28
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Hash::Util::FieldHash) perl(XSLoader)
%if 0%{?perl_bootstrap}
%gendep_perl_Hash_Util
%endif

%description Hash-Util
Hash::Util contains special functions for manipulating hashes that don't
really warrant a keyword.

%package Hash-Util-FieldHash
Summary:        Support for inside-out classes
Version:        1.26
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(XSLoader)
%if 0%{?perl_bootstrap}
%gendep_perl_Hash_Util_FieldHash
%endif

%description Hash-Util-FieldHash
Hash::Util::FieldHash offers a number of functions in support of the
inside-out technique of class construction.

%package if
Summary:        Use a Perl module if a condition holds
Version:        0.61.000
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_if
%endif
BuildArch:      noarch

%description if
The "if" module is used to conditionally load another module.

%package IO
Summary:        Perl input/output modules
Version:        1.50
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_IO
%endif

%description IO
This is a collection of Perl input/output modules.

%package IPC-Open3
Summary:        Open a process for reading, writing, and error handling
Version:        1.22
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Fcntl) perl(IO::Pipe) perl(POSIX) perl(warnings)
%if 0%{?perl_bootstrap}
%gendep_perl_IPC_Open3
%endif
BuildArch:      noarch

%description IPC-Open3
These are functions that spawn a given command and connects the standard
output of the command for reading, standard output for writing, and standard
error output for handling the errors.

%package I18N-Collate
Summary:        Compare 8-bit scalar data according to the current locale
Version:        1.02
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_I18N_Collate
%endif
BuildArch:      noarch

%description I18N-Collate
This module provides you with objects that will collate according to your
national character set. This module is deprecated. See the perllocale manual
page for further information.

%package I18N-Langinfo
Summary:        Query locale information
Version:        0.21
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_I18N_Langinfo
%endif

%description I18N-Langinfo
The langinfo() function queries various locale information that can be used to
localize output and user interfaces. It uses the current underlying locale,
regardless of whether or not it was called from within the scope of "use
locale".

%package I18N-LangTags
Summary:        Functions for dealing with RFC 3066 language tags
Version:        0.45
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(integer) perl(warnings)
%if 0%{?perl_bootstrap}
%gendep_perl_I18N_LangTags
%endif
BuildArch:      noarch

%description I18N-LangTags
Language tags are a formalism, described in RFC 3066, for declaring what
language form (language and possibly dialect) a given chunk of information is
in. This library provides functions for common tasks involving language tags
as they are needed in a variety of protocols and applications.

%package less
Summary:        Perl pragma to request less of something
Version:        0.03
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_less
%endif
BuildArch:      noarch

%description less
"use less ...;" is a Perl user-pragma. If you're very lucky some code you're
using will know that you asked for less CPU usage or RAM or fat or... we just
can't know.

%package lib
Summary:        Manipulate @INC at compile time
Version:        0.65
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_lib
%endif

%description lib
This module simplifies the manipulation of @INC at compile time.

%package libnetcfg
Summary:        Configure libnet
Version:        %perl_version
License:        GPL+ or Artistic
%if 0%{?perl_bootstrap}
%gendep_perl_libnetcfg
%endif
BuildArch:      noarch

%description libnetcfg
The libnetcfg utility can be used to configure the libnet.

%package locale
Summary:        Pragma to use or avoid POSIX locales for built-in operations
Version:        1.10
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(POSIX)
%if 0%{?perl_bootstrap}
%gendep_perl_locale
%endif
BuildArch:      noarch

%description locale
This pragma tells the compiler to enable (or disable) the use of POSIX locales
for built-in operations (for example, LC_CTYPE for regular expressions,
LC_COLLATE for string comparison, and LC_NUMERIC for number formatting). Each
"use locale" or "no locale" affects statements to the end of the enclosing
block.

%package Locale-Maketext-Simple
Summary:        Simple interface to Locale::Maketext::Lexicon
Version:        0.21
License:        MIT
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Locale_Maketext_Simple
%endif
BuildArch:      noarch

%description Locale-Maketext-Simple
This module is a simple wrapper around Locale::Maketext::Lexicon, designed
to alleviate the need of creating Language Classes for module authors.

%package Math-Complex
Summary:        Complex numbers and trigonometric functions
Version:        1.59
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Math_Complex
%endif
BuildArch:      noarch

%description Math-Complex
This package lets you create and manipulate complex numbers. By default, Perl
limits itself to real numbers, but an extra "use" statement brings full
complex support, along with a full set of mathematical functions typically
associated with and/or extended to complex numbers.

%package Memoize
Summary:        Transparently speed up functions by caching return values
Version:        1.03
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Memoize
%endif
BuildArch:      noarch

%description Memoize
Memoizing a function makes it faster by trading space for time. It does
this by caching the return values of the function in a table. If you call
the function again with the same arguments, memoize jumps in and gives
you the value out of the table, instead of letting the function compute
the value all over again.

%package meta-notation
Summary:        Change nonprintable characters below 0x100 into printables
Version:        %{perl_version}
License:        GPL+ or Artistic
Provides:       perl(meta_notation) = %{perl_version}
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_meta_notation
%endif
BuildArch:      noarch

%description meta-notation
Returns a copy of the input string with the nonprintable characters below
0x100 changed into printables. Any ASCII printables or above 0xFF are
unchanged.

%package Module-Loaded
Summary:        Mark modules as loaded or unloaded
Version:        0.08
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Module_Loaded
%endif
BuildArch:      noarch

%description Module-Loaded
When testing applications, often you find yourself needing to provide
functionality in your test environment that would usually be provided by
external modules. Rather than munging the %%INC by hand to mark these external
modules as loaded, so they are not attempted to be loaded by perl, this module
offers you a very simple way to mark modules as loaded and/or unloaded.

%package mro
Summary:        Method resolution order
Version:        1.26
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_mro
%endif

%description mro
The "mro" name space provides several utilities for dealing with method
resolution order and method caching in general.

%package NDBM_File
Summary:        Tied access to ndbm files
Version:        1.15
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_NDBM_File
%endif

%description NDBM_File
NDBM_File establishes a connection between a Perl hash variable and a file in
ndbm format. You can manipulate the data in the file just as if it were in
a Perl hash, but when your program exits, the data will remain in the file, to
be used the next time your program runs.

%package Net
Summary:        By-name interface to Perl built-in network resolver
Version:        1.03
License:        GPL+ or Artistic
BuildArch:      noarch
Requires:       %perl_compat
Requires:       perl(Socket)
%if 0%{?perl_bootstrap}
%gendep_perl_Net
%endif

%description Net
This package provide object-oriented interface to Perl built-in gethost*(),
getnet*(), getproto*(), and getserv*() functions.

%package NEXT
Summary:        Pseudo-class that allows method redispatch
Version:        0.69
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_NEXT
%endif
BuildArch:      noarch

%description NEXT
The NEXT module adds a pseudo-class named "NEXT" to any program that uses it.
If a method "m" calls "$self->NEXT::m()", the call to "m" is redispatched as
if the calling method had not originally been found.

%package ODBM_File
Summary:        Tied access to odbm files
Version:        1.17
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_ODBM_File
%endif

%description ODBM_File
ODBM_File establishes a connection between a Perl hash variable and a file in
odbm format. You can manipulate the data in the file just as if it were in
a Perl hash, but when your program exits, the data will remain in the file, to
be used the next time your program runs.

%package Opcode
Summary:        Disable named opcodes when compiling a perl code
Version:        1.57
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Opcode
%endif

%description Opcode
The Opcode module allows you to define an operator mask to be in effect when
perl next compiles any code. Attempting to compile code which contains
a masked opcode will cause the compilation to fail with an error. The code
will not be executed.

%package open
Summary:        Perl pragma to set default PerlIO layers for input and output
Version:        1.13
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(Encode) perl(encoding)
%if 0%{?perl_bootstrap}
%gendep_perl_open
%endif
BuildArch:      noarch

%description open
The "open" pragma serves as one of the interfaces to declare default "layers"
(also known as "disciplines") for all I/O.

%package overload
Summary:        Overloading Perl operations
Version:        1.35
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(mro) perl(Scalar::Util) perl(overloading)
%if 0%{?perl_bootstrap}
%gendep_perl_overload
%endif
BuildArch:      noarch

%description overload
The "overload" pragma allows overloading of Perl operators for a class. To
overload built-in functions, see "Overriding Built-in Functions" in perlsub
POD instead.

%package overloading
Summary:        Perl pragma to lexically control overloading
Version:        0.02
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_overloading
%endif
BuildArch:      noarch

%description overloading
Overloading pragma allows you to lexically disable or enable overloading.

%package ph
Summary:        Selected system header files converted to Perl headers
Version:        %{perl_version}
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl-libs = %{perl_version}-%{release}
Requires:       perl(warnings)
Provides:       perl(sys/ioctl.ph) = %{perl_version}
Provides:       perl(sys/syscall.ph) = %{perl_version}
Provides:       perl(syscall.ph) = %{perl_version}
%if 0%{?perl_bootstrap}
%gendep_perl_ph
%endif

%description ph
Contemporary Perl still refers to some Perl header (ph) files although it does
not build them anymore. This is a prebuilt collection of the referred files.
If you miss other ones, you can generate them with h2ph tool from perl-utils
package.

%package Pod-Functions
Summary:        Group Perl functions as in perlfunc POD
Version:        1.14
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl-libs = %{perl_version}-%{release}
%if 0%{?perl_bootstrap}
%gendep_perl_Pod_Functions
%endif
BuildArch:      noarch

%description Pod-Functions
This module enumerates the Perl functions that are documented in perlfunc POD.

%package Pod-Html
Summary:        Convert POD files to HTML
Version:        1.33
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Pod_Html
%endif
BuildArch:      noarch

%description Pod-Html
This package converts files from POD format (see perlpod) to HTML format. It
can automatically generate indexes and cross-references, and it keeps a cache
of things it knows how to cross-reference.

%package POSIX
Summary:        Perl interface to IEEE Std 1003.1
Version:        2.03
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_POSIX
%endif

%description POSIX
The POSIX module permits you to access all (or nearly all) the standard POSIX
1003.1 identifiers. Many of these identifiers have been given Perl interfaces.

%package Safe
Summary:        Compile and execute code in restricted compartments
Version:        2.43
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Safe
%endif
BuildArch:      noarch

%description Safe
The Safe extension module allows the creation of compartments in which Perl
code can be evaluated. Please note that the restriction is not suitable for
security purposes.

%package Search-Dict
Summary:        Search for a key in a dictionary file
Version:        1.07
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(feature)
%if 0%{?perl_bootstrap}
%gendep_perl_Search_Dict
%endif
BuildArch:      noarch

%description Search-Dict
This module sets file position in a file handle to be first line greater than
or equal (string-wise) to a key.

%package SelectSaver
Summary:        Save and restore selected file handle
Version:        1.02
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_SelectSaver
%endif
BuildArch:      noarch

%description SelectSaver
A "SelectSaver" object contains a reference to the file handle that was
selected when it was created. When the object is destroyed, it re-selects the
file handle that was selected when it was created.

%package SelfLoader
Summary:        Load functions only on demand
Version:        1.26
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_SelfLoader
%endif
BuildArch:      noarch

%description SelfLoader
This Perl module tells its users that functions in a package are to be
autoloaded from after the "__DATA__" token. See also "Autoloading" in
perlsub.

%package sigtrap
Summary:        Perl pragma to enable simple signal handling
Version:        1.10
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(meta_notation) = %{perl_version}
Requires:       perl(Symbol)
%if 0%{?perl_bootstrap}
%gendep_perl_sigtrap
%endif
BuildArch:      noarch

%description sigtrap
The sigtrap pragma is a simple interface for installing signal handlers.

%package sort
Summary:        Perl pragma to control sort() behavior
Version:        2.05
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(warnings)
%if 0%{?perl_bootstrap}
%gendep_perl_sort
%endif
BuildArch:      noarch

%description sort
With the "sort" pragma you can control the behavior of the builtin "sort()"
function.

%package subs
Summary:        Perl pragma to predeclare subroutine names
Version:        1.04
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_subs
%endif
BuildArch:      noarch

%description subs
This will predeclare all the subroutines whose names are in the list,
allowing you to use them without parentheses (as list operators) even
before they're declared.

%package Symbol
Summary:        Manipulate Perl symbols and their names
Version:        1.09
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Symbol
%endif
BuildArch:      noarch

%description Symbol
The Symbol module provides functions for manipulating Perl symbols.

%package Sys-Hostname
Summary:        Try every conceivable way to get a hostname
Version:        1.24
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(XSLoader)
%if 0%{?perl_bootstrap}
%gendep_perl_Sys_Hostname
%endif
Suggests:       perl(POSIX)

%description Sys-Hostname
It attempts several methods of getting the system hostname and then caches the
result.

%package Term-Complete
Summary:        Perl word completion
Version:        1.403
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Term_Complete
%endif
BuildArch:      noarch

%description Term-Complete
"Complete" routine provides word completion on a list of words in the array.

%package Term-ReadLine
Summary:        Perl interface to various read-line packages
Version:        1.17
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Term::Cap)
%if 0%{?perl_bootstrap}
%gendep_perl_Term_ReadLine
%endif
BuildArch:      noarch

%description Term-ReadLine
This package is just a front end to some other packages. It's a stub to
set up a common interface to the various read-line implementations found
on CPAN (under the "Term::ReadLine::*" name space).

%package Test
Summary:        Simple framework for writing test scripts
Version:        1.31
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(File::Temp)
%if 0%{?perl_bootstrap}
%gendep_perl_Test
%endif
BuildArch:      noarch

%description Test
The Test Perl module simplifies the task of writing test files for Perl modules,
such that their output is in the format that Test::Harness expects to see.

%package Text-Abbrev
Summary:        Create an abbreviation table from a list
Version:        1.02
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Text_Abbrev
%endif
BuildArch:      noarch

%description Text-Abbrev
It stores all unambiguous truncations of each element of a list as keys in
an associative array. The values are the original list elements.

%package Thread
Summary:        Manipulate threads in Perl (for old code only)
Version:        3.05
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Thread
%endif
BuildArch:      noarch

%description Thread
This Thread module served as the front end to the old-style thread model,
called 5005threads, that has been removed in version 5.10.

For old code and interim backwards compatibility, the Thread module has been
reworked to function as a front end for the new interpreter threads (ithreads)
model. However, some previous functionality is not available. Further, the
data sharing models between the two thread models are completely different,
and anything to do with data sharing has to be thought differently.

You are strongly encouraged to migrate any existing threaded code to the new
model (i.e., use the threads and threads::shared modules) as soon as possible.

%package Tie
Summary:        Base classes for tying variables
Version:        4.6
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Tie
%endif
BuildArch:      noarch

%description Tie
These are Perl modules that helps connecting classes with arrays, hashes,
handles, and scalars.

%package Tie-File
Summary:        Access the lines of a disk file via a Perl array
Version:        1.06
License:        GPLv2+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Tie_File
%endif
BuildArch:      noarch

%description Tie-File
Tie::File represents a regular text file as a Perl array. Each element in the
array corresponds to a record in the file. The first line of the file is
element 0 of the array; the second line is element 1, and so on.  The file is
not loaded into memory, so this will work even for gigantic files.  Changes to
the array are reflected in the file immediately.

%package Tie-Memoize
Summary:        Add data to a hash when needed
Version:        1.1
License:        GPLv2+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp) perl(Tie::ExtraHash)
%if 0%{?perl_bootstrap}
%gendep_perl_Tie_Memoize
%endif
BuildArch:      noarch

%description Tie-Memoize
This package allows a tied hash to load its values automatically on the first
access, and to use the cached value on the following accesses.

%package Time
Summary:        By-name interface to Perl built-in time functions
Version:        1.03
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Time
%endif
BuildArch:      noarch

%description Time
This package provides an object-oriented interface to Perl built-in gmtime()
and localtime () functions.

%package Time-Piece
Summary:        Time objects from localtime and gmtime
License:        (GPL+ or Artistic) and BSD
Version:        1.3401
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_Time_Piece
%endif

%description Time-Piece
The Time::Piece module replaces the standard localtime and gmtime functions
with implementations that return objects.  It does so in a backwards compatible
manner, so that using localtime or gmtime as documented in perlfunc still
behave as expected.

%package Thread-Semaphore
Summary:        Thread-safe semaphores
Version:        2.13
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_Thread_Semaphore
%endif
BuildArch:      noarch

%description Thread-Semaphore
Semaphores provide a mechanism to regulate access to resources. Unlike locks,
semaphores aren't tied to particular scalars, and so may be used to control
access to anything you care to use them for. Semaphores don't limit their
values to zero and one, so they can be used to control access to some resource
that there may be more than one of (e.g., file handles). Increment and
decrement amounts aren't fixed at one either, so threads can reserve or return
multiple resources at once.

%package Unicode-UCD
Summary:        Unicode character database
Version:        0.78
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Storable)
%if 0%{?perl_bootstrap}
%gendep_perl_Unicode_UCD
%endif
BuildArch:      noarch

%description Unicode-UCD
The Unicode::UCD module offers a series of functions that provide a simple
interface to the Unicode Character Database.

%package User-pwent
Summary:        By-name interface to Perl built-in user name resolver
Version:        1.03
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_User_pwent
%endif
BuildArch:      noarch

%description User-pwent
This package provides an object-oriented interface to Perl build-in getgr*()
and getpw*() functions.

%package vars
Summary:        Perl pragma to predeclare global variable names
Version:        1.05
License:        GPL+ or Artistic
Requires:       %perl_compat
Requires:       perl(Carp)
%if 0%{?perl_bootstrap}
%gendep_perl_vars
%endif
BuildArch:      noarch

%description vars
This pragma will predeclare all the variables whose names are in the
list, allowing you to use them under "use strict", and disabling any
typo warnings for them.

For use with variables in the current package for a single scope, the
functionality provided by this pragma has been superseded by "our"
declarations, available in Perl v5.6.0 or later, and use of this pragma is
discouraged.

%package vmsish
Summary:        Perl pragma to control VMS-specific language features
Version:        1.04
License:        GPL+ or Artistic
Requires:       %perl_compat
%if 0%{?perl_bootstrap}
%gendep_perl_vmsish
%endif
BuildArch:      noarch

%description vmsish
The "vmsish" pragma control VMS-specific features of the Perl language. If
you're not running VMS, this module does nothing.

%if 0%{?perl_bootstrap}
# bootstrap packages
%include %{SOURCE6}
%endif

%prep
%autosetup -p1

install -p -m 0644 %{SOURCE3} .
install -p -m 0644 %{SOURCE4} .

sed -i 's|\(BUILD_ZLIB.*\)True|\1False| 
        s|\(INCLUDE.*\)./zlib-src|\1%{_includedir}| 
		s|\(LIB.*\)./zlib-src|\1%{_libdir}|' \
		cpan/Compress-Raw-Zlib/config.in

rm -rf cpan/Compress-Raw-Zlib/zlib-src
rm -rf cpan/Compress-Raw-Bzip2/bzip2-src
sed -i '/\(bzip2\|zlib\)-src/d' MANIFEST

%build
/bin/sh Configure -des \
        -Doptimize="none" \
        -Dccflags="$RPM_OPT_FLAGS" \
        -Dldflags="$RPM_LD_FLAGS" \
        -Dccdlflags="-Wl,--enable-new-dtags $RPM_LD_FLAGS" \
        -Dlddlflags="-shared $RPM_LD_FLAGS" \
        -Dshrpdir="%{_libdir}" \
        -DDEBUGGING=-g \
        -Dcc='%{__cc}' \
        -Dversion=%{perl_version} \
        -Dmyhostname=localhost \
        -Dperladmin=root@localhost \
        -Dcf_by='%{_vendor}' \
        -Dprefix=%{_prefix} \
        -Dvendorprefix=%{_prefix} \
        -Dsiteprefix=%{_prefix}/local \
        -Dsitelib="%{_prefix}/local/share/perl5/%{perl_version_short}" \
        -Dsitearch="%{_prefix}/local/%{_lib}/perl5/%{perl_version_short}" \
        -Dprivlib="%{privlib}" \
        -Dvendorlib="%{perl_vendorlib}" \
        -Darchlib="%{archlib}" \
        -Dvendorarch="%{perl_vendorarch}" \
        -Darchname=%{_arch}-%{_os}-thread-multi \
        -Dlibpth="%{_prefix}/local/%{_lib} /%{_lib} %{_libdir}" \
        -Dscriptdir='%{_bindir}' \
        -Dman3ext=3pm \
        -Dpager='/usr/bin/less -isr' \
        -Dinstallusrbinperl=n \
        -Dusedtrace='/usr/bin/dtrace' -Uusedtrace \
        -Duseshrplib -Dusethreads -Duseithreads \
        -Duselargefiles -Dd_semctl_semun \
        -Di_db -Ui_ndbm -Di_gdbm -Di_shadow \
        -Di_syslog -Duseperlio -Ubincompat5005 -Uversiononly \
        -Dd_gethostent_r_proto -Ud_endhostent_r_proto -Ud_sethostent_r_proto \
        -Ud_endprotoent_r_proto -Ud_setprotoent_r_proto \
        -Ud_endservent_r_proto -Ud_setservent_r_proto \
        -Ud_strlcpy -Ud_strlcat \
        -Dusesitecustomize -Duse64bitint

export BUILD_BZIP2=0 BZIP2_LIB=%{_libdir}
test -L libperl.so.%{perl_version_short} || ln -s libperl.so libperl.so.%{perl_version_short}
%make_build

%install
%make_install

mv %{buildroot}%{archlib}/CORE/libperl.so %{buildroot}%{_libdir}/libperl.so.%{perl_version}
ln -s "libperl.so.%{perl_version}" "%{buildroot}%{_libdir}/libperl.so.%{perl_version_short}"
ln -s "libperl.so.%{perl_version}" "%{buildroot}%{_libdir}/libperl.so"
ln -s "../../libperl.so.%{perl_version}" "%{buildroot}%{archlib}/CORE/libperl.so"
rm "%{buildroot}%{archlib}/CORE/libperl.so.%{perl_version_short}"

for i in sys/ioctl.h sys/syscall.h syscall.h; do
    %{new_perl} %{buildroot}%{_bindir}/h2ph -a -d %{buildroot}%{archlib} $i || true
done

mkdir -p %{buildroot}%{perl_vendorarch}/auto
mkdir -p %{buildroot}%{perl_vendorlib}

install -D -m 0644 %{SOURCE1} %{buildroot}%{_rpmmacrodir}/macros.perl

chmod -R u+w %{buildroot}/*

rm %{buildroot}%{privlib}/ExtUtils/xsubpp
ln -s ../../../bin/xsubpp %{buildroot}%{privlib}/ExtUtils/

rm %{buildroot}%{archlib}/.packlist
rm %{buildroot}%{archlib}/File/Spec/VMS.pm
rm %{buildroot}%{_mandir}/man3/File::Spec::VMS.3*
rm %{buildroot}%{privlib}/ExtUtils/PL2Bat.pm
rm %{buildroot}%{_mandir}/man3/ExtUtils::PL2Bat.3*

mkdir -p %{buildroot}%{_systemtap_tapsetdir}
sed -e "s|LIBRARY_PATH|%{_libdir}/libperl.so.%{perl_version_short}|" %{SOURCE2} \
  > %{buildroot}%{_systemtap_tapsetdir}/libperl%{perl_version}-64.stp

%if ! 0%{?perl_bootstrap}
# remove unpackaged files
%include %{SOURCE7}
%endif

%check
%{new_perl} -I./lib regen/lib_cleanup.pl
pushd t
%{new_perl} -I../lib porting/customized.t --regen
popd
LC_ALL=C TEST_JOBS=%{_smp_build_ncpus} make test_harness

%files

%files interpreter
%{_bindir}/perl
%{_bindir}/perl%{perl_version}
%dir %{privlib}/pod
%{privlib}/pod/perl.pod
%{privlib}/pod/perlrun.pod
%{_mandir}/man1/perl.1*
%{_mandir}/man1/perlrun.1*

%files libs
%license Artistic Copying
%doc AUTHORS README Changes
%dir %{archlib}
%{archlib}/attributes.pm
%dir %{archlib}/auto
%dir %{archlib}/auto/attributes
%{archlib}/auto/attributes/attributes.so
%dir %{archlib}/auto/File
%dir %{archlib}/auto/File/Glob
%{archlib}/auto/File/Glob/Glob.so
%{archlib}/auto/PerlIO
%{archlib}/auto/re
%{archlib}/auto/SDBM_File
%{archlib}/Config.*
%{archlib}/Config_git.pl
%{archlib}/Config_heavy.pl
%dir %{archlib}/CORE
%{archlib}/CORE/libperl.so
%dir %{archlib}/File
%{archlib}/File/Glob.pm
%{archlib}/PerlIO
%{archlib}/re.pm
%{archlib}/SDBM_File.pm
%{_libdir}/libperl.so.*
%dir %{perl_vendorarch}
%dir %{perl_vendorarch}/auto
%dir %{privlib}
%{privlib}/AnyDBM_File.pm
%{privlib}/builtin.pm
%{privlib}/bytes.pm
%{privlib}/bytes_heavy.pl
%{privlib}/_charnames.pm
%{privlib}/charnames.pm
%{privlib}/CORE.pod
%{privlib}/feature.pm
%{privlib}/integer.pm
%{privlib}/PerlIO.pm
%{privlib}/strict.pm
%{privlib}/unicore
%{privlib}/UNIVERSAL.pm
%{privlib}/utf8.pm
%{privlib}/warnings
%{privlib}/warnings.pm
%dir %{privlib}/Tie
%{privlib}/Tie/Hash.pm
%dir %{privlib}/Tie/Hash
%{privlib}/Tie/Hash/NamedCapture.pm
%{privlib}/XSLoader.pm
%dir %{perl_vendorlib}
%{privlib}/Internals.pod
%{_mandir}/man3/AnyDBM_File.*
%{_mandir}/man3/attributes.*
%{_mandir}/man3/builtin.*
%{_mandir}/man3/bytes.*
%{_mandir}/man3/charnames.*
%{_mandir}/man3/Config.*
%{_mandir}/man3/CORE.*
%{_mandir}/man3/feature.3*
%{_mandir}/man3/File::Glob.*
%{_mandir}/man3/integer.*
%{_mandir}/man3/Internals.*
%{_mandir}/man3/PerlIO.*
%{_mandir}/man3/PerlIO::encoding.*
%{_mandir}/man3/PerlIO::mmap.*
%{_mandir}/man3/PerlIO::scalar.*
%{_mandir}/man3/PerlIO::via.*
%{_mandir}/man3/re.*
%{_mandir}/man3/SDBM_File.3*
%{_mandir}/man3/strict.*
%{_mandir}/man3/Tie::Hash.*
%{_mandir}/man3/Tie::Hash::*
%{_mandir}/man3/unicore*
%{_mandir}/man3/utf8.*
%{_mandir}/man3/warnings.*
%{_mandir}/man3/warnings::*
%{_mandir}/man3/UNIVERSAL.*
%{_mandir}/man3/XSLoader.*

%files devel
%doc perl-example.stp
%{archlib}/CORE/*.h
%dir %{privlib}/ExtUtils
%{privlib}/ExtUtils/typemap
%dir %{_datadir}/systemtap
%dir %{_datadir}/systemtap/tapset
%{_systemtap_tapsetdir}/libperl%{perl_version}-64.stp
%{_bindir}/h2xs
%{_bindir}/perlivp
%{_libdir}/libperl.so
%{_mandir}/man1/h2xs*
%{_mandir}/man1/perlivp*

%files debugger
%{privlib}/DB.pm
%{privlib}/dumpvar.pl
%{privlib}/perl5db.pl
%dir %{privlib}/pod
%{privlib}/pod/perldebug.pod
%{_mandir}/man1/perldebug.*
%{_mandir}/man3/DB.*

%files doc
%dir %{privlib}/pod
%{privlib}/pod/perl5*delta.pod
%{privlib}/pod/perlaix.pod
%{privlib}/pod/perlamiga.pod
%{privlib}/pod/perlandroid.pod
%{privlib}/pod/perlapi.pod
%{privlib}/pod/perlapio.pod
%{privlib}/pod/perlartistic.pod
%{privlib}/pod/perlbook.pod
%{privlib}/pod/perlboot.pod
%{privlib}/pod/perlbot.pod
%{privlib}/pod/perlbs2000.pod
%{privlib}/pod/perlcall.pod
%{privlib}/pod/perlcheat.pod
%{privlib}/pod/perlclib.pod
%{privlib}/pod/perlcn.pod
%{privlib}/pod/perlcommunity.pod
%{privlib}/pod/perlcygwin.pod
%{privlib}/pod/perldata.pod
%{privlib}/pod/perldbmfilter.pod
%{privlib}/pod/perldebguts.pod
%{privlib}/pod/perldebtut.pod
%{privlib}/pod/perldelta.pod
%{privlib}/pod/perldeprecation.pod
%{privlib}/pod/perldocstyle.pod
%{privlib}/pod/perldsc.pod
%{privlib}/pod/perldtrace.pod
%{privlib}/pod/perlebcdic.pod
%{privlib}/pod/perlembed.pod
%{privlib}/pod/perlexperiment.pod
%{privlib}/pod/perlfork.pod
%{privlib}/pod/perlform.pod
%{privlib}/pod/perlfreebsd.pod
%{privlib}/pod/perlfunc.pod
%{privlib}/pod/perlgit.pod
%{privlib}/pod/perlgov.pod
%{privlib}/pod/perlgpl.pod
%{privlib}/pod/perlguts.pod
%{privlib}/pod/perlhack.pod
%{privlib}/pod/perlhacktips.pod
%{privlib}/pod/perlhacktut.pod
%{privlib}/pod/perlhaiku.pod
%{privlib}/pod/perlhist.pod
%{privlib}/pod/perlhpux.pod
%{privlib}/pod/perlhurd.pod
%{privlib}/pod/perlintern.pod
%{privlib}/pod/perlinterp.pod
%{privlib}/pod/perlintro.pod
%{privlib}/pod/perliol.pod
%{privlib}/pod/perlipc.pod
%{privlib}/pod/perlirix.pod
%{privlib}/pod/perljp.pod
%{privlib}/pod/perlko.pod
%{privlib}/pod/perllexwarn.pod
%{privlib}/pod/perllinux.pod
%{privlib}/pod/perllocale.pod
%{privlib}/pod/perllol.pod
%{privlib}/pod/perlmacosx.pod
%{privlib}/pod/perlmod.pod
%{privlib}/pod/perlmodinstall.pod
%{privlib}/pod/perlmodlib.pod
%{privlib}/pod/perlmodstyle.pod
%{privlib}/pod/perlmroapi.pod
%{privlib}/pod/perlnewmod.pod
%{privlib}/pod/perlnumber.pod
%{privlib}/pod/perlobj.pod
%{privlib}/pod/perlootut.pod
%{privlib}/pod/perlop.pod
%{privlib}/pod/perlopenbsd.pod
%{privlib}/pod/perlopentut.pod
%{privlib}/pod/perlos2.pod
%{privlib}/pod/perlos390.pod
%{privlib}/pod/perlos400.pod
%{privlib}/pod/perlpacktut.pod
%{privlib}/pod/perlperf.pod
%{privlib}/pod/perlplan9.pod
%{privlib}/pod/perlpod.pod
%{privlib}/pod/perlpodspec.pod
%{privlib}/pod/perlpolicy.pod
%{privlib}/pod/perlport.pod
%{privlib}/pod/perlpragma.pod
%{privlib}/pod/perlqnx.pod
%{privlib}/pod/perlre.pod
%{privlib}/pod/perlreapi.pod
%{privlib}/pod/perlrebackslash.pod
%{privlib}/pod/perlrecharclass.pod
%{privlib}/pod/perlref.pod
%{privlib}/pod/perlreftut.pod
%{privlib}/pod/perlreguts.pod
%{privlib}/pod/perlrepository.pod
%{privlib}/pod/perlrequick.pod
%{privlib}/pod/perlreref.pod
%{privlib}/pod/perlretut.pod
%{privlib}/pod/perlriscos.pod
%{privlib}/pod/perlsec.pod
%{privlib}/pod/perlsecpolicy.pod
%{privlib}/pod/perlsolaris.pod
%{privlib}/pod/perlsource.pod
%{privlib}/pod/perlstyle.pod
%{privlib}/pod/perlsub.pod
%{privlib}/pod/perlsyn.pod
%{privlib}/pod/perlsynology.pod
%{privlib}/pod/perlthrtut.pod
%{privlib}/pod/perltie.pod
%{privlib}/pod/perltoc.pod
%{privlib}/pod/perltodo.pod
%{privlib}/pod/perltooc.pod
%{privlib}/pod/perltoot.pod
%{privlib}/pod/perltrap.pod
%{privlib}/pod/perltru64.pod
%{privlib}/pod/perltw.pod
%{privlib}/pod/perlunicode.pod
%{privlib}/pod/perlunicook.pod
%{privlib}/pod/perlunifaq.pod
%{privlib}/pod/perluniintro.pod
%{privlib}/pod/perluniprops.pod
%{privlib}/pod/perlunitut.pod
%{privlib}/pod/perlvar.pod
%{privlib}/pod/perlvms.pod
%{privlib}/pod/perlvos.pod
%{privlib}/pod/perlwin32.pod
%{_mandir}/man1/perl5*delta.*
%{_mandir}/man1/perlaix.*
%{_mandir}/man1/perlamiga.*
%{_mandir}/man1/perlandroid.*
%{_mandir}/man1/perlapi.*
%{_mandir}/man1/perlapio.*
%{_mandir}/man1/perlartistic.*
%{_mandir}/man1/perlbook.*
%{_mandir}/man1/perlboot.*
%{_mandir}/man1/perlbot.*
%{_mandir}/man1/perlbs2000.*
%{_mandir}/man1/perlcall.*
%{_mandir}/man1/perlcheat.*
%{_mandir}/man1/perlclib.*
%{_mandir}/man1/perlcn.*
%{_mandir}/man1/perlcommunity.*
%{_mandir}/man1/perlcygwin.*
%{_mandir}/man1/perldata.*
%{_mandir}/man1/perldbmfilter.*
%{_mandir}/man1/perldebguts.*
%{_mandir}/man1/perldebtut.*
%{_mandir}/man1/perldelta.*
%{_mandir}/man1/perldeprecation.*
%{_mandir}/man1/perldocstyle.*
%{_mandir}/man1/perldsc.*
%{_mandir}/man1/perldtrace.*
%{_mandir}/man1/perlebcdic.*
%{_mandir}/man1/perlembed.*
%{_mandir}/man1/perlexperiment.*
%{_mandir}/man1/perlfork.*
%{_mandir}/man1/perlform.*
%{_mandir}/man1/perlfreebsd.*
%{_mandir}/man1/perlfunc.*
%{_mandir}/man1/perlgit.*
%{_mandir}/man1/perlgov.*
%{_mandir}/man1/perlgpl.*
%{_mandir}/man1/perlguts.*
%{_mandir}/man1/perlhack.*
%{_mandir}/man1/perlhacktips.*
%{_mandir}/man1/perlhacktut.*
%{_mandir}/man1/perlhaiku.*
%{_mandir}/man1/perlhist.*
%{_mandir}/man1/perlhpux.*
%{_mandir}/man1/perlhurd.*
%{_mandir}/man1/perlintern.*
%{_mandir}/man1/perlinterp.*
%{_mandir}/man1/perlintro.*
%{_mandir}/man1/perliol.*
%{_mandir}/man1/perlipc.*
%{_mandir}/man1/perlirix.*
%{_mandir}/man1/perljp.*
%{_mandir}/man1/perlko.*
%{_mandir}/man1/perllexwarn.*
%{_mandir}/man1/perllinux.*
%{_mandir}/man1/perllocale.*
%{_mandir}/man1/perllol.*
%{_mandir}/man1/perlmacosx.*
%{_mandir}/man1/perlmod.*
%{_mandir}/man1/perlmodinstall.*
%{_mandir}/man1/perlmodlib.*
%{_mandir}/man1/perlmodstyle.*
%{_mandir}/man1/perlmroapi.*
%{_mandir}/man1/perlnewmod.*
%{_mandir}/man1/perlnumber.*
%{_mandir}/man1/perlobj.*
%{_mandir}/man1/perlootut.*
%{_mandir}/man1/perlop.*
%{_mandir}/man1/perlopenbsd.*
%{_mandir}/man1/perlopentut.*
%{_mandir}/man1/perlos2.*
%{_mandir}/man1/perlos390.*
%{_mandir}/man1/perlos400.*
%{_mandir}/man1/perlpacktut.*
%{_mandir}/man1/perlperf.*
%{_mandir}/man1/perlplan9.*
%{_mandir}/man1/perlpod.*
%{_mandir}/man1/perlpodspec.*
%{_mandir}/man1/perlpolicy.*
%{_mandir}/man1/perlport.*
%{_mandir}/man1/perlpragma.*
%{_mandir}/man1/perlqnx.*
%{_mandir}/man1/perlre.*
%{_mandir}/man1/perlreapi.*
%{_mandir}/man1/perlrebackslash.*
%{_mandir}/man1/perlrecharclass.*
%{_mandir}/man1/perlref.*
%{_mandir}/man1/perlreftut.*
%{_mandir}/man1/perlreguts.*
%{_mandir}/man1/perlrepository.*
%{_mandir}/man1/perlrequick.*
%{_mandir}/man1/perlreref.*
%{_mandir}/man1/perlretut.*
%{_mandir}/man1/perlriscos.*
%{_mandir}/man1/perlsec.*
%{_mandir}/man1/perlsecpolicy.*
%{_mandir}/man1/perlsolaris.*
%{_mandir}/man1/perlsource.*
%{_mandir}/man1/perlstyle.*
%{_mandir}/man1/perlsub.*
%{_mandir}/man1/perlsyn.*
%{_mandir}/man1/perlsynology.*
%{_mandir}/man1/perlthrtut.*
%{_mandir}/man1/perltie.*
%{_mandir}/man1/perltoc.*
%{_mandir}/man1/perltodo.*
%{_mandir}/man1/perltooc.*
%{_mandir}/man1/perltoot.*
%{_mandir}/man1/perltrap.*
%{_mandir}/man1/perltru64.*
%{_mandir}/man1/perltw.*
%{_mandir}/man1/perlunicode.*
%{_mandir}/man1/perlunicook.*
%{_mandir}/man1/perlunifaq.*
%{_mandir}/man1/perluniintro.*
%{_mandir}/man1/perluniprops.*
%{_mandir}/man1/perlunitut.*
%{_mandir}/man1/perlvar.*
%{_mandir}/man1/perlvms.*
%{_mandir}/man1/perlvos.*
%{_mandir}/man1/perlwin32.*

%files macros
%{_rpmmacrodir}/macros.perl

%files utils
%{_bindir}/h2ph
%{_bindir}/perlbug
%{_bindir}/perlthanks
%{_bindir}/pl2pm
%dir %{privlib}/pod
%{privlib}/pod/perlutil.pod
%{_mandir}/man1/h2ph.*
%{_mandir}/man1/perlbug.*
%{_mandir}/man1/perlthanks.*
%{_mandir}/man1/perlutil.*
%{_mandir}/man1/pl2pm.*

%files Attribute-Handlers
%{privlib}/Attribute
%{_mandir}/man3/Attribute::Handlers.*

%files AutoLoader
%{privlib}/AutoLoader.pm
%{_mandir}/man3/AutoLoader.3*

%files AutoSplit
%{privlib}/AutoSplit.pm
%{_mandir}/man3/AutoSplit.3*

%files autouse
%{privlib}/autouse.pm
%{_mandir}/man3/autouse.3*

%files B
%{archlib}/auto/B
%{archlib}/B
%{archlib}/B.pm
%{archlib}/O.pm
%{privlib}/B
%{_mandir}/man3/B.*
%{_mandir}/man3/B::*
%{_mandir}/man3/O.*

%files base
%{privlib}/base.pm
%{_mandir}/man3/base.3*

%files Benchmark
%{privlib}/Benchmark.pm
%{_mandir}/man3/Benchmark.*

%files blib
%{privlib}/blib.pm
%{_mandir}/man3/blib.*

%files Class-Struct
%{privlib}/Class
%{_mandir}/man3/Class::Struct.*

%files Config-Extensions
%dir %{privlib}/Config
%{privlib}/Config/Extensions.pm
%{_mandir}/man3/Config::Extensions.*

%files DBM_Filter
%{privlib}/DBM_Filter
%{privlib}/DBM_Filter.pm
%{_mandir}/man3/DBM_Filter.*
%{_mandir}/man3/DBM_Filter::*

%files deprecate
%{privlib}/deprecate.pm
%{_mandir}/man3/deprecate.*

%files Devel-Peek
%dir %{archlib}/Devel
%{archlib}/Devel/Peek.pm
%dir %{archlib}/auto/Devel
%{archlib}/auto/Devel/Peek
%{_mandir}/man3/Devel::Peek.*

%files Devel-SelfStubber
%dir %{privlib}/Devel
%{privlib}/Devel/SelfStubber.pm
%{_mandir}/man3/Devel::SelfStubber.*

%files diagnostics
%{privlib}/diagnostics.pm
%{_bindir}/splain
%dir %{privlib}/pod
%{privlib}/pod/perldiag.pod
%{_mandir}/man1/perldiag.*
%{_mandir}/man1/splain.*
%{_mandir}/man3/diagnostics.*

%files DirHandle
%{privlib}/DirHandle.pm
%{_mandir}/man3/DirHandle.3*

%files Dumpvalue
%{privlib}/Dumpvalue.pm
%{_mandir}/man3/Dumpvalue.3*

%files DynaLoader
%{archlib}/DynaLoader.pm
%{_mandir}/man3/DynaLoader.3*

%files encoding-warnings
%dir %{privlib}/encoding
%{privlib}/encoding/warnings.pm
%{_mandir}/man3/encoding::warnings.3*

%files English
%{privlib}/English.pm
%{_mandir}/man3/English.3*

%files Errno
%{archlib}/Errno.pm
%{_mandir}/man3/Errno.*

%files ExtUtils-Constant
%dir %{privlib}/ExtUtils
%{privlib}/ExtUtils/Constant
%{privlib}/ExtUtils/Constant.pm
%{_mandir}/man3/ExtUtils::Constant::*
%{_mandir}/man3/ExtUtils::Constant.3*

%files ExtUtils-Embed
%dir %{privlib}/ExtUtils
%{privlib}/ExtUtils/Embed.pm
%{_mandir}/man3/ExtUtils::Embed*

%files ExtUtils-Miniperl
%dir %{privlib}/ExtUtils
%{privlib}/ExtUtils/Miniperl.pm
%{_mandir}/man3/ExtUtils::Miniperl.3*

%files Fcntl
%{archlib}/Fcntl.pm
%{archlib}/auto/Fcntl
%{_mandir}/man3/Fcntl.3*

%files fields
%{privlib}/fields.pm
%{_mandir}/man3/fields.3*

%files File-Basename
%dir %{privlib}/File
%{privlib}/File/Basename.pm
%{_mandir}/man3/File::Basename.3*

%files File-Compare
%dir %{privlib}/File
%{privlib}/File/Compare.pm
%{_mandir}/man3/File::Compare.3*

%files File-Copy
%dir %{privlib}/File
%{privlib}/File/Copy.pm
%{_mandir}/man3/File::Copy.3*

%files File-DosGlob
%dir %{archlib}/File
%{archlib}/File/DosGlob.pm
%dir %{archlib}/auto/File
%{archlib}/auto/File/DosGlob
%{_mandir}/man3/File::DosGlob.3*

%files File-Find
%dir %{privlib}/File
%{privlib}/File/Find.pm
%{_mandir}/man3/File::Find.3*

%files File-stat
%dir %{privlib}/File
%{privlib}/File/stat.pm
%{_mandir}/man3/File::stat.3*

%files FileCache
%{privlib}/FileCache.pm
%{_mandir}/man3/FileCache.3*

%files FileHandle
%{privlib}/FileHandle.pm
%{_mandir}/man3/FileHandle.3*

%files filetest
%{privlib}/filetest.pm
%{_mandir}/man3/filetest.3*

%files FindBin
%{privlib}/FindBin.pm
%{_mandir}/man3/FindBin.*

%files GDBM_File
%{archlib}/GDBM_File.pm
%{archlib}/auto/GDBM_File
%{_mandir}/man3/GDBM_File.3*

%files Getopt-Std
%dir %{privlib}/Getopt
%{privlib}/Getopt/Std.pm
%{_mandir}/man3/Getopt::Std.3*

%files Hash-Util
%dir %{archlib}/Hash
%{archlib}/Hash/Util.pm
%dir %{archlib}/auto/Hash
%dir %{archlib}/auto/Hash/Util
%{archlib}/auto/Hash/Util/Util.so
%{_mandir}/man3/Hash::Util.3*

%files Hash-Util-FieldHash
%dir %{archlib}/auto/Hash
%dir %{archlib}/auto/Hash/Util
%{archlib}/auto/Hash/Util/FieldHash
%dir %{archlib}/Hash
%dir %{archlib}/Hash/Util
%{archlib}/Hash/Util/FieldHash.pm
%{_mandir}/man3/Hash::Util::FieldHash.3*

%files if
%{privlib}/if.pm
%{_mandir}/man3/if.3*

%files IO
%dir %{archlib}/IO
%{archlib}/IO.pm
%{archlib}/IO/Dir.pm
%{archlib}/IO/File.pm
%{archlib}/IO/Handle.pm
%{archlib}/IO/Pipe.pm
%{archlib}/IO/Poll.pm
%{archlib}/IO/Seekable.pm
%{archlib}/IO/Select.pm
%dir %{archlib}/IO/Socket
%{archlib}/IO/Socket/INET.pm
%{archlib}/IO/Socket/UNIX.pm
%{archlib}/IO/Socket.pm
%dir %{archlib}/auto/IO
%{archlib}/auto/IO/IO.so
%{_mandir}/man3/IO.*
%{_mandir}/man3/IO::Dir.*
%{_mandir}/man3/IO::File.*
%{_mandir}/man3/IO::Handle.*
%{_mandir}/man3/IO::Pipe.*
%{_mandir}/man3/IO::Poll.*
%{_mandir}/man3/IO::Seekable.*
%{_mandir}/man3/IO::Select.*
%{_mandir}/man3/IO::Socket::INET.*
%{_mandir}/man3/IO::Socket::UNIX.*
%{_mandir}/man3/IO::Socket.*

%files IPC-Open3
%dir %{privlib}/IPC
%{privlib}/IPC/Open2.pm
%{privlib}/IPC/Open3.pm
%{_mandir}/man3/IPC::Open2.3*
%{_mandir}/man3/IPC::Open3.3*

%files I18N-Collate
%dir %{privlib}/I18N
%{privlib}/I18N/Collate.pm
%{_mandir}/man3/I18N::Collate.*

%files I18N-Langinfo
%{archlib}/auto/I18N
%{archlib}/I18N
%{_mandir}/man3/I18N::Langinfo.*

%files I18N-LangTags
%dir %{privlib}/I18N
%{privlib}/I18N/LangTags
%{privlib}/I18N/LangTags.pm
%{_mandir}/man3/I18N::LangTags.*
%{_mandir}/man3/I18N::LangTags::*

%files less
%{privlib}/less.pm
%{_mandir}/man3/less.*

%files lib
%{archlib}/lib.pm
%{_mandir}/man3/lib.*

%files libnetcfg
%{_bindir}/libnetcfg
%{_mandir}/man1/libnetcfg*

%files locale
%{privlib}/locale.pm
%{_mandir}/man3/locale.*

%files Locale-Maketext-Simple
%dir %{privlib}/Locale
%dir %{privlib}/Locale/Maketext
%{privlib}/Locale/Maketext/Simple.pm
%{_mandir}/man3/Locale::Maketext::Simple.*

%files Math-Complex
%dir %{privlib}/Math
%{privlib}/Math/Complex.pm
%{privlib}/Math/Trig.pm
%{_mandir}/man3/Math::Complex.*
%{_mandir}/man3/Math::Trig.*

%files Memoize
%{privlib}/Memoize
%{privlib}/Memoize.pm
%{_mandir}/man3/Memoize::*
%{_mandir}/man3/Memoize.*

%files meta-notation
%{privlib}/meta_notation.pm

%files Module-Loaded
%dir %{privlib}/Module
%{privlib}/Module/Loaded.pm
%{_mandir}/man3/Module::Loaded*

%files mro
%{archlib}/auto/mro
%{archlib}/mro.pm
%{_mandir}/man3/mro.3*

%files NDBM_File
%{archlib}/NDBM_File.pm
%{archlib}/auto/NDBM_File
%{_mandir}/man3/NDBM_File.3*

%files Net
%dir %{privlib}/Net
%{privlib}/Net/hostent.pm
%{privlib}/Net/netent.pm
%{privlib}/Net/protoent.pm
%{privlib}/Net/servent.pm
%{_mandir}/man3/Net::hostent.3*
%{_mandir}/man3/Net::netent.3*
%{_mandir}/man3/Net::protoent.3*
%{_mandir}/man3/Net::servent.3*

%files NEXT
%{privlib}/NEXT.pm
%{_mandir}/man3/NEXT.*

%files ODBM_File
%{archlib}/ODBM_File.pm
%{archlib}/auto/ODBM_File
%{_mandir}/man3/ODBM_File.3*

%files open
%{privlib}/open.pm
%{_mandir}/man3/open.3*

%files Opcode
%{archlib}/auto/Opcode
%{archlib}/Opcode.pm
%{archlib}/ops.pm
%{_mandir}/man3/Opcode.3*
%{_mandir}/man3/ops.3*

%files overload
%{privlib}/overload.pm
%{_mandir}/man3/overload.3*

%files overloading
%dir %{privlib}/overload
%{privlib}/overload/numbers.pm
%{privlib}/overloading.pm
%{_mandir}/man3/overloading.3*

%files ph
%{archlib}/asm
%{archlib}/asm-generic
%{archlib}/bits
%{archlib}/features*.ph
%{archlib}/gnu
%{archlib}/_h2ph_pre.ph
%ifnarch ppc64le
%{archlib}/linux
%endif
%{archlib}/stdc-predef.ph
%{archlib}/sys
%{archlib}/syscall.ph

%files Pod-Functions
%dir %{privlib}/Pod
%{privlib}/Pod/Functions.pm

%files Pod-Html
%license Pod-Html-license-clarification
%{_bindir}/pod2html
%dir %{privlib}/Pod
%{privlib}/Pod/Html
%{privlib}/Pod/Html.pm
%{_mandir}/man1/pod2html.1*
%{_mandir}/man3/Pod::Html*

%files POSIX
%{archlib}/auto/POSIX
%{archlib}/POSIX.*
%{_mandir}/man3/POSIX.*

%files Safe
%{privlib}/Safe.pm
%{_mandir}/man3/Safe.*

%files Search-Dict
%{privlib}/Search
%{_mandir}/man3/Search::*

%files SelectSaver
%{privlib}/SelectSaver.pm
%{_mandir}/man3/SelectSaver.*

%files SelfLoader
%{privlib}/SelfLoader.pm
%{_mandir}/man3/SelfLoader.*

%files sigtrap
%{privlib}/sigtrap.pm
%{_mandir}/man3/sigtrap.*

%files sort
%{privlib}/sort.pm
%{_mandir}/man3/sort.*

%files subs
%{privlib}/subs.pm
%{_mandir}/man3/subs.*

%files Symbol
%{privlib}/Symbol.pm
%{_mandir}/man3/Symbol.*

%files Sys-Hostname
%dir %{archlib}/auto/Sys
%{archlib}/auto/Sys/Hostname
%dir %{archlib}/Sys
%{archlib}/Sys/Hostname.pm
%{_mandir}/man3/Sys::Hostname.*

%files Term-Complete
%dir %{privlib}/Term
%{privlib}/Term/Complete.pm
%{_mandir}/man3/Term::Complete.*

%files Term-ReadLine
%dir %{privlib}/Term
%{privlib}/Term/ReadLine.pm
%{_mandir}/man3/Term::ReadLine.*

%files Test
%{privlib}/Test.pm
%{_mandir}/man3/Test.*

%files Text-Abbrev
%dir %{privlib}/Text
%{privlib}/Text/Abbrev.pm
%{_mandir}/man3/Text::Abbrev.*

%files Thread
%{privlib}/Thread.pm
%{_mandir}/man3/Thread.*

%files Thread-Semaphore
%dir %{privlib}/Thread
%{privlib}/Thread/Semaphore.pm
%{_mandir}/man3/Thread::Semaphore.*

%files Tie
%dir %{privlib}/Tie
%{privlib}/Tie/Array.pm
%{privlib}/Tie/Handle.pm
%{privlib}/Tie/Scalar.pm
%{privlib}/Tie/StdHandle.pm
%{privlib}/Tie/SubstrHash.pm
%{_mandir}/man3/Tie::Array.*
%{_mandir}/man3/Tie::Handle.*
%{_mandir}/man3/Tie::Scalar.*
%{_mandir}/man3/Tie::StdHandle.*
%{_mandir}/man3/Tie::SubstrHash.*

%files Tie-File
%dir %{privlib}/Tie
%{privlib}/Tie/File.pm
%{_mandir}/man3/Tie::File.*

%files Tie-Memoize
%dir %{privlib}/Tie
%{privlib}/Tie/Memoize.pm
%{_mandir}/man3/Tie::Memoize.*

%files Time
%dir %{privlib}/Time
%{privlib}/Time/gmtime.pm
%{privlib}/Time/localtime.pm
%{privlib}/Time/tm.pm
%{_mandir}/man3/Time::gmtime.*
%{_mandir}/man3/Time::localtime.*
%{_mandir}/man3/Time::tm.*

%files Time-Piece
%dir %{archlib}/Time
%{archlib}/Time/Piece.pm 
%{archlib}/Time/Seconds.pm
%dir %{archlib}/auto/Time
%{archlib}/auto/Time/Piece
%{_mandir}/man3/Time::Piece.3*
%{_mandir}/man3/Time::Seconds.3*

%files Unicode-UCD
%dir %{privlib}/Unicode
%{privlib}/Unicode/UCD.pm
%{_mandir}/man3/Unicode::UCD.*

%files User-pwent
%{privlib}/User
%{_mandir}/man3/User::*

%files vars
%{privlib}/vars.pm
%{_mandir}/man3/vars.*

%files vmsish
%{privlib}/vmsish.pm
%{_mandir}/man3/vmsish.*

%changelog
* Fri Dec 01 2023 Xiaojie Chen <jackxjchen@tencent.com> - 5.36.0-8
- Fix CVE-2023-47038

* Mon Oct 23 2023 Xiaojie Chen <jackxjchen@tencent.com> - 5.36.0-7
- Add Patch0001 and Patch0002 to fix CVE-2023-31486 and CVE-2023-31484

* Mon Sep 11 2023 Xiaojie Chen <jackxjchen@tencent.com> - 5.36.0-6
- Explicitly do not use strlcpy and strlcat from glibc 2.38

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.36.0-5
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.36.0-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.36.0-3
- Rebuilt for OpenCloudOS Stream 23

* Fri Feb 24 2023 Xiaojie Chen <jackxjchen@tencent.com> - 5.36.0-2
- Replace OpenCloudOS with macro %{_vendor}

* Tue Aug 2 2022 Xiaojie Chen <jackxjchen@tencent.com> - 5.36.0-1
- Initial build
